using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MySql.Data.MySqlClient;

namespace MySqlClientBug
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnCaso1_Click(object sender, EventArgs e)
        {
            try
            {
                MySqlConnection conn = new MySqlConnection("SERVER = Localhost;DATABASE = test;UID = root;PASSWORD = 123;");
                MySqlCommand comando = new MySqlCommand("spwithparams", conn);
                comando.CommandType = System.Data.CommandType.StoredProcedure;
                conn.Open();
                MySqlCommandBuilder.DeriveParameters(comando);
                conn.Close();
                foreach(MySqlParameter par in comando.Parameters)
                {
                    par.Value = 2;
                }
                MySqlDataAdapter adp = new MySqlDataAdapter(comando);
                System.Data.DataSet DS = new System.Data.DataSet();
                adp.Fill(DS);
                this.dtgDatos.DataSource = DS.Tables[0];
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void btnCaso2_Click(object sender, EventArgs e)
        {
            try
            {
                MySqlConnection conn = new MySqlConnection("SERVER = Localhost;DATABASE = test;UID = root;PASSWORD = 123;");
                MySqlCommand comando = new MySqlCommand("spwithoutparams", conn);
                comando.CommandType = System.Data.CommandType.StoredProcedure;
                conn.Open();
                MySqlCommandBuilder.DeriveParameters(comando);
                conn.Close();
                foreach (MySqlParameter par in comando.Parameters)
                {
                    par.Value = 2;
                }
                MySqlDataAdapter adp = new MySqlDataAdapter(comando);
                System.Data.DataSet DS = new System.Data.DataSet();
                adp.Fill(DS);
                this.dtgDatos.DataSource = DS.Tables[0];
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
    }
}