-- I use Test database
-- --------------------------------------------------------------------
-- Crea la Tabla
-- --------------------------------------------------------------------
DROP TABLE IF EXISTS `test`.`mytable`;
CREATE TABLE  `test`.`mytable` 
(
`TableID` int(10) unsigned NOT NULL auto_increment,
`Name` varchar(45) NOT NULL default '',
PRIMARY KEY  (`TableID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------------------
-- Stored procedure without parameters
-- --------------------------------------------------------------------
DELIMITER $$

DROP PROCEDURE IF EXISTS `test`.`spWithoutParams` $$
CREATE PROCEDURE `spWithoutParams`()
BEGIN
  SELECT * FROM mytable;
END $$

DELIMITER ;
-- --------------------------------------------------------------------
-- Stored procedure with parameters
-- --------------------------------------------------------------------
DELIMITER $$

DROP PROCEDURE IF EXISTS `test`.`spWithParams` $$
CREATE PROCEDURE `spWithParams`(tableid int)
BEGIN

  SELECT * FROM mytable WHERE  mytable.tableid = tableid;

END $$

DELIMITER ;

